function res = eval_kl(xqs, xq, xp, knlparam)

hknl = @knl_radial;

Ns = size(xqs,1);

% knlparam = 50;

fq = zeros(Ns,1);
fp = zeros(Ns,1);

for ii=1:1000:Ns
    cidx = ii:min(ii+1000-1, Ns);
    
    K = hknl(xqs(cidx,:), xq, knlparam);
    fq(cidx) = mean(K,2);
    K = hknl(xqs(cidx,:), xp, knlparam);
    fp(cidx) = mean(K,2);
end

res = mean(log(fq./fp));

end

%{
function res = eval_kl(xs, xt, xe, knlparam)

hknl = @knl_radial;

Ns = size(xs,1);

% knlparam = 50;

ft = zeros(Ns,1);
fe = zeros(Ns,1);

for ii=1:1000:Ns
    cidx = ii:min(ii+1000-1, Ns);
    
    K = hknl(xs(cidx,:), xt, knlparam);
    ft(cidx) = mean(K,2);
    K = hknl(xs(cidx,:), xe, knlparam);
    fe(cidx) = mean(K,2);
end

res = mean(log(ft./fe));

end
%}

% 
% function res = eval_kl(xs, x, knlparam)
% 
% hknl = @knl_radial;
% 
% Ns = size(xs,1);
% 
% fs = zeros(Ns,1);
% for ii=1:1000:Ns
%     cidx = ii:min(ii+1000-1, Ns);
%     
%     K = hknl(xs(cidx,:), x, knlparam);
%     fs(cidx) = mean(K,2);
% end
% 
% res = mean(log(fs));
% 
% end


function res = eval_kl3(xs, x, knlparam)

hknl = @knl_radial;

N = size(x,1);
Ns = size(xs,1);

% dssum = 0;
% for ii=1:1000:N
%     cidx = ii:min(ii+1000-1, N);
%     
%     ds = util_dist2(x(cidx,:));
%     
%     dssum = dssum + sum(ds(:));
% end
% dsavg = dssum / (N*(N-1));

% knlparam = dsavg;

% knlparam = 50;

%%
%{
[xx1 xx2] = ndgrid(0:10:1023,0:10:1023);
xx = [xx1(:), xx2(:)];

%%
mpair = [5 6];
fx = zeros(size(xx,1),1);
for ii=1:1000:size(xx)
    cidx = ii:min(ii+1000-1, size(xx,1));
    K = hknl(xx(cidx,:), x(:,mpair), knlparam);
    fx(cidx) = mean(K,2);
end
fx = reshape(fx, size(xx1));

plot(x(:,mpair(1)), x(:,mpair(2)), '.b', xs(:,mpair(1)), xs(:,mpair(2)), '.r', 'markersize', 5)
hold on, contour (xx1, xx2, fx, 20); hold off
axis([0 1023 0 1023]), axis square
%}

%%

fs = zeros(Ns,1);
for ii=1:1000:Ns
    cidx = ii:min(ii+1000-1, Ns);
    
    K = hknl(xs(cidx,:), x, knlparam);
    fs(cidx) = mean(K,2);
end

res = mean(log(fs));

end


function res = eval_kl2(xs, param)


mu = param.mu;
W = param.W;
sig = param.sigma;
pp = param.pp;

[post, ll, logpdf] = ppca_md_E(xs, mu, W, sig, pp);

res = mean(logpdf);

end

