
function [x1, x2] = ppca_md_nn(x1, x2, feature, param)

dp = feature(:,1);
dq = feature(:,2);
dr = feature(:,3);

x1_nk = ppca_md_cluster(param, x1, dp|dq, dr);
x2_nk = ppca_md_cluster(param, x2, dp|dr, dq);

for k=1:param.K
    x1k = find(x1_nk==k);
    x2k = find(x2_nk==k);
    
    if isempty(x2k)
        x2k = (1:size(x2,1))';
    end
    
    for ii=1:1000:size(x1k,1)
        cellidx = ii:min(ii+1000-1, size(x1k,1));
        ds = util_dist2(x1(x1k(cellidx),dp), x2(x2k,dp));
        [temp, dsidx] = min(ds,[],2);
        x1(x1k(cellidx),dr) = x2(x2k(dsidx),dr);
    end
    
    if (nargout>1)
        x1k = find(x1_nk==k);
        x2k = find(x2_nk==k);

        if isempty(x1k)
            x1k = (1:size(x1,1))';
        end
        
        for ii=1:1000:size(x2k,1)
            cellidx = ii:min(ii+1000-1, size(x2k,1));
            ds = util_dist2(x2(x2k(cellidx),dp), x1(x1k,dp));
            [temp, dsidx] = min(ds,[],2);
            x2(x2k(cellidx),dq) = x1(x1k(dsidx),dq);
        end
    end
end

